Index: factory/int_poly.cc
===================================================================
--- factory/int_poly.cc	(revision a718906498691a0860e186cfee5db4fc1142ccd6)
+++ factory/int_poly.cc	(revision aa7c1c2e9f1abb961d220f98916b45111ff94b84)
@@ -30,4 +30,12 @@
 #include "variable.h"
 #include "imm.h"
+
+#ifdef __GNUC__
+#define LIKELY(X)   (__builtin_expect(!!(X), 1))
+#define UNLIKELY(X) (__builtin_expect(!!(X), 0))
+#else
+#define LIKELY(X)   (X)
+#define UNLIKELY(X) (X)
+#endif
 
 #ifdef HAVE_OMALLOC
@@ -2155,5 +2163,5 @@
         {
             theCursor->coeff += aCursor->coeff * coeff;
-            if ( theCursor->coeff.isZero() )
+            if(UNLIKELY(( theCursor->coeff.isZero() )))
             {
                 if ( predCursor )
Index: kernel/GBEngine/kstd2.cc
===================================================================
--- kernel/GBEngine/kstd2.cc	(revision a718906498691a0860e186cfee5db4fc1142ccd6)
+++ kernel/GBEngine/kstd2.cc	(revision aa7c1c2e9f1abb961d220f98916b45111ff94b84)
@@ -2227,29 +2227,30 @@
   }
   else if (TEST_OPT_PROT) PrintLn();
-  if (!errorreported)
-  {
-    if(rField_is_Ring_Z(currRing))
-    {
-      for(int i = 0;i<=strat->sl;i++)
-      {
-        if(!nGreaterZero(pGetCoeff(strat->S[i])))
-        {
-          strat->S[i] = pNeg(strat->S[i]);
-        }
-      }
-      finalReduceByMon(strat);
-      for(int i = 0;i<=strat->sl;i++)
-      {
-        if(!nGreaterZero(pGetCoeff(strat->S[i])))
-        {
-          strat->S[i] = pNeg(strat->S[i]);
-        }
-      }
-    }
-    else if (rField_is_Ring(currRing))
-      finalReduceByMon(strat);
-  }
   /* release temp data-------------------------------- */
   exitBuchMora(strat);
+  /* postprocessing for GB over ZZ --------------------*/
+  if (!errorreported)
+  {
+    if(rField_is_Ring_Z(currRing))
+    {
+      for(int i = 0;i<=strat->sl;i++)
+      {
+        if(!nGreaterZero(pGetCoeff(strat->S[i])))
+        {
+          strat->S[i] = pNeg(strat->S[i]);
+        }
+      }
+      finalReduceByMon(strat);
+      for(int i = 0;i<IDELEMS(strat->Shdl);i++)
+      {
+        if(!nGreaterZero(pGetCoeff(strat->Shdl->m[i])))
+        {
+          strat->S[i] = pNeg(strat->Shdl->m[i]);
+        }
+      }
+    }
+    //else if (rField_is_Ring(currRing))
+    //  finalReduceByMon(strat);
+  }
 //  if (TEST_OPT_WEIGHTM)
 //  {
@@ -2263,4 +2264,5 @@
   if ((TEST_OPT_PROT) || (TEST_OPT_DEBUG)) messageStat(hilbcount,strat);
   SI_RESTORE_OPT1(save);
+  /* postprocessing for GB over Q-rings ------------------*/
   if ((Q!=NULL)&&(!errorreported)) updateResult(strat->Shdl,Q,strat);
 
Index: kernel/GBEngine/kutil.cc
===================================================================
--- kernel/GBEngine/kutil.cc	(revision a718906498691a0860e186cfee5db4fc1142ccd6)
+++ kernel/GBEngine/kutil.cc	(revision aa7c1c2e9f1abb961d220f98916b45111ff94b84)
@@ -10971,41 +10971,67 @@
 void finalReduceByMon(kStrategy strat)
 {
+  assume(strat->tl<0); /* can only be called with no elements in T:
+                          i.e. after exitBuchMora */
+  /* do not use strat->S, strat->sl as they may be out of sync*/
   if(!nCoeff_is_Ring_Z(currRing->cf))
       return;
   poly p,pp;
-  for(int j = 0; j<=strat->sl; j++)
-  {
-    if((strat->S[j]!=NULL)&&(pNext(strat->S[j]) == NULL))
-    {
-      for(int i = 0; i<=strat->sl; i++)
-      {
-        if((i != j) && (strat->S[i] != NULL))
-        {
-          p = strat->S[i];
-          if(pLmDivisibleBy(strat->S[j], p))
+  for(int j = 0; j<IDELEMS(strat->Shdl); j++)
+  {
+    if((strat->Shdl->m[j]!=NULL)&&(pNext(strat->Shdl->m[j]) == NULL))
+    {
+      for(int i = 0; i<IDELEMS(strat->Shdl); i++)
+      {
+        if((i != j) && (strat->Shdl->m[i] != NULL))
+        {
+          p = strat->Shdl->m[i];
+          while((p!=NULL) && pLmDivisibleBy(strat->Shdl->m[j], p))
           {
-            number dummy = n_IntMod(p->coef, strat->S[j]->coef, currRing->cf);
-            p_SetCoeff(p,dummy,currRing);
+            number dummy = n_IntMod(p->coef, strat->Shdl->m[j]->coef, currRing->cf);
+            if (!nEqual(dummy,p->coef))
+            {
+              if (nIsZero(dummy))
+              {
+                nDelete(&dummy);
+                pLmDelete(&strat->Shdl->m[i]);
+                p=strat->Shdl->m[i];
+              }
+              else
+              {
+                p_SetCoeff(p,dummy,currRing);
+                break;
+              }
+            }
+            else
+            {
+              nDelete(&dummy);
+              break;
+            }
           }
-          pp = pNext(p);
-          if((pp == NULL) && (nIsZero(p->coef)))
+          if (p!=NULL)
           {
-            deleteInS(i, strat);
-          }
-          else
-          {
+            pp = pNext(p);
             while(pp != NULL)
             {
-              if(pLmDivisibleBy(strat->S[j], pp))
+              if(pLmDivisibleBy(strat->Shdl->m[j], pp))
               {
-                number dummy = n_IntMod(pp->coef, strat->S[j]->coef, currRing->cf);
-                p_SetCoeff(pp,dummy,currRing);
-                if(nIsZero(pp->coef))
+                number dummy = n_IntMod(pp->coef, strat->Shdl->m[j]->coef, currRing->cf);
+                if (!nEqual(dummy,pp->coef))
                 {
-                  pLmDelete(&pNext(p));
-                  pp = pNext(p);
+                  p_SetCoeff(pp,dummy,currRing);
+                  if(nIsZero(pp->coef))
+                  {
+                    pLmDelete(&pNext(p));
+                    pp = pNext(p);
+                  }
+                  else
+                  {
+                    p = pp;
+                    pp = pNext(p);
+                  }
                 }
                 else
                 {
+                  nDelete(&dummy);
                   p = pp;
                   pp = pNext(p);
@@ -11019,11 +11045,4 @@
             }
           }
-          if(strat->S[i]!= NULL && nIsZero(pGetCoeff(strat->S[i])))
-          {
-            if(pNext(strat->S[i]) == NULL)
-              strat->S[i]=NULL;
-            else
-              strat->S[i]=pNext(strat->S[i]);
-          }
         }
       }
@@ -11031,5 +11050,5 @@
     }
   }
-  //idSkipZeroes(strat->Shdl);
+  idSkipZeroes(strat->Shdl);
 }
 #endif
Index: libpolys/coeffs/modulop.cc
===================================================================
--- libpolys/coeffs/modulop.cc	(revision a718906498691a0860e186cfee5db4fc1142ccd6)
+++ libpolys/coeffs/modulop.cc	(revision aa7c1c2e9f1abb961d220f98916b45111ff94b84)
@@ -344,6 +344,5 @@
 {
   if (setChar) setCharacteristic( r->ch );
-  CanonicalForm term(npInt( n,r ));
-  return term;
+  return CanonicalForm(npInt( n,r ));
 }
 
Index: libpolys/polys/clapconv.cc
===================================================================
--- libpolys/polys/clapconv.cc	(revision a718906498691a0860e186cfee5db4fc1142ccd6)
+++ libpolys/polys/clapconv.cc	(revision aa7c1c2e9f1abb961d220f98916b45111ff94b84)
@@ -94,6 +94,5 @@
   while ( p!=NULL )
   {
-    CanonicalForm term;
-    term=r->cf->convSingNFactoryN(pGetCoeff( p ),setChar, r->cf);
+    CanonicalForm term=r->cf->convSingNFactoryN(pGetCoeff( p ),setChar, r->cf);
     if (errorreported) break;
     setChar=FALSE;
@@ -101,5 +100,5 @@
     {
       if ( (e = p_GetExp( p, i, r)) != 0 )
-        term *= power( Variable( i ), e );
+        term *= CanonicalForm( Variable( i ), e );
     }
     result += term;
Index: libpolys/polys/ext_fields/transext.cc
===================================================================
--- libpolys/polys/ext_fields/transext.cc	(revision a718906498691a0860e186cfee5db4fc1142ccd6)
+++ libpolys/polys/ext_fields/transext.cc	(revision aa7c1c2e9f1abb961d220f98916b45111ff94b84)
@@ -1484,5 +1484,11 @@
     if (nCoeff_is_Zp(ntCoeffs))
     {
-      NUM (f) = p_Div_nn (NUM (f), p_GetCoeff (DEN(f),ntRing), ntRing);
+      number d=p_GetCoeff (DEN(f),ntRing);
+      BOOLEAN d_not_1=FALSE;
+      if (!n_IsOne(d,ntCoeffs))
+      {
+        NUM (f) = p_Div_nn (NUM (f), d, ntRing);
+        d_not_1=TRUE;
+      }
       if (p_IsConstant (DEN (f), ntRing))
       {
@@ -1490,7 +1496,7 @@
         DEN (f) = NULL;
       }
-      else
-      {
-        p_Norm (DEN (f),ntRing);
+      else if (d_not_1)
+      {
+        DEN (f) = p_Div_nn (DEN (f), d, ntRing);
       }
     } else if (nCoeff_is_Q(ntCoeffs)) handleNestedFractionsOverQ(f, cf);
@@ -2547,6 +2553,6 @@
   cf->cfChineseRemainder = ntChineseRemainder;
   cf->cfInt          = ntInt;
-  cf->cfInpNeg          = ntNeg;
   cf->cfAdd          = ntAdd;
+  cf->cfInpNeg       = ntNeg;
   cf->cfSub          = ntSub;
   cf->cfMult         = ntMult;
Index: libpolys/polys/matpol.cc
===================================================================
--- libpolys/polys/matpol.cc	(revision a718906498691a0860e186cfee5db4fc1142ccd6)
+++ libpolys/polys/matpol.cc	(revision aa7c1c2e9f1abb961d220f98916b45111ff94b84)
@@ -1775,3 +1775,123 @@
   return res;
 }
-
+// --------------------------------------------------------------------------
+/****************************************
+*  Computer Algebra System SINGULAR     *
+****************************************/
+
+/*
+* ABSTRACT: basic operation for sparse matrices:
+* type: ideal (of column vectors)
+* nrows: I->rank, ncols: IDELEMS(I)
+*/
+
+ideal sm_Add(ideal a, ideal b, const ring R)
+{
+  assume(IDELEMS(a)==IDELEMS(b));
+  assume(a->rank==b->rank);
+  ideal c=idInit(IDELEMS(a),a->rank);
+  for (int k=IDELEMS(a)-1; k>=0; k--)
+    c->m[k] = p_Add_q(p_Copy(a->m[k], R), p_Copy(b->m[k], R), R);
+  return c;
+}
+
+ideal sm_Sub(ideal a, ideal b, const ring R)
+{
+  assume(IDELEMS(a)==IDELEMS(b));
+  assume(a->rank==b->rank);
+  ideal c=idInit(IDELEMS(a),a->rank);
+  for (int k=IDELEMS(a)-1; k>=0; k--)
+    c->m[k] = p_Sub(p_Copy(a->m[k], R), p_Copy(b->m[k], R), R);
+  return c;
+}
+
+#define SMATELEM(A,i,j,R) p_Vec2Poly(A->m[j],i+1,R)
+ideal sm_Mult(ideal a, ideal b, const ring R)
+{
+  int i, j, k;
+  int m = a->rank;
+  int p = IDELEMS(a);
+  int q = IDELEMS(b);
+
+  assume (IDELEMS(a)==b->rank);
+  ideal c = idInit(m,q);
+
+  for (i=0; i<m; i++)
+  {
+    for (k=0; k<p; k++)
+    {
+      poly aik;
+      if ((aik=SMATELEM(a,i,k,R))!=NULL)
+      {
+        for (j=0; j<q; j++)
+        {
+          poly bkj;
+          if ((bkj=SMATELEM(b,k,j,R))!=NULL)
+          {
+            poly s = p_Mult_q(p_Copy(aik,R) /*SMATELEM(a,i,k)*/, bkj/*SMATELEM(b,k,j)*/, R);
+            if (s!=NULL) p_SetComp(s,i+1,R);
+            c->m[j]=p_Add_q(c->m[j],s, R);
+          }
+        }
+        p_Delete(&aik,R);
+      }
+    }
+  }
+  for(i=m-1;i>=0;i--) p_Normalize(c->m[i], R);
+  return c;
+}
+
+ideal sm_Transp(ideal a, const ring R)
+{
+  int    i, j, r = a->rank, c = IDELEMS(a);
+  poly *p;
+  ideal b =  idInit(c,r);
+  poly *m=(poly*)omAlloc0(r*sizeof(poly));
+  for(i=0;i<c;i++)
+  {
+    p_Vec2Polys(a->m[i],&m,&r,R);// m has A[1..r,i+1]
+    if (r>a->rank) Print("wrong rang (%d,%ld) in sm_Transp\n",r,a->rank);
+    for(j=0;j<r;j++)
+    {
+      // m[j] is A[j+1,i]
+      p_SetCompP(m[j],i+1,R);
+      b->m[j]=p_Add_q(b->m[j],m[j],R);
+    }
+  }
+  omFreeSize(m,a->rank*sizeof(poly));
+  return b;
+}
+
+/*2
+*returns the trace of matrix a
+*/
+poly sm_Trace ( ideal a, const ring R)
+{
+  int i;
+  int n = (IDELEMS(a)<a->rank) ? IDELEMS(a) : a->rank;
+  poly  t = NULL;
+
+  for (i=0; i<=n; i++)
+    t = p_Add_q(t, p_Copy(SMATELEM(a,i,i,R), R), R);
+  return t;
+}
+
+int sm_Compare(ideal a, ideal b, const ring R)
+{
+  if (IDELEMS(a)<IDELEMS(b)) return -1;
+  else if (IDELEMS(a)>IDELEMS(b)) return 1;
+  if ((a->rank)<(b->rank)) return -1;
+  else if ((a->rank)<(b->rank)) return 1;
+
+  unsigned ii=IDELEMS(a)-1;
+  unsigned j=0;
+  int r=0;
+  while (j<=ii)
+  {
+    r=p_Compare(a->m[j],b->m[j],R);
+    if (r!=0) return r;
+    j++;
+  }
+  return r;
+}
+
Index: libpolys/polys/matpol.h
===================================================================
--- libpolys/polys/matpol.h	(revision a718906498691a0860e186cfee5db4fc1142ccd6)
+++ libpolys/polys/matpol.h	(revision aa7c1c2e9f1abb961d220f98916b45111ff94b84)
@@ -95,3 +95,10 @@
 
 ideal mp_Tensor(ideal A, ideal B, const ring r);
+// -------------------------------------------------------
+ideal sm_Add(ideal a, ideal b, const ring R);
+ideal sm_Sub(ideal a, ideal b, const ring R);
+ideal sm_Mult(ideal a, ideal b, const ring R);
+ideal sm_Transp(ideal a, const ring R);
+poly sm_Trace ( ideal a, const ring R);
+int sm_Compare(ideal a, ideal b, const ring R);
 #endif/* MATPOL_H */
Index: libpolys/polys/monomials/p_polys.cc
===================================================================
--- libpolys/polys/monomials/p_polys.cc	(revision a718906498691a0860e186cfee5db4fc1142ccd6)
+++ libpolys/polys/monomials/p_polys.cc	(revision aa7c1c2e9f1abb961d220f98916b45111ff94b84)
@@ -3547,4 +3547,23 @@
 }
 
+poly p_Vec2Poly(poly v, int k, const ring r)
+{
+  poly h;
+  poly res=NULL;
+
+  while (v!=NULL)
+  {
+    if (__p_GetComp(v,r)==k)
+    {
+      h=p_Head(v,r);
+      p_SetComp(h,0,r);
+      pNext(h)=res;res=h;
+    }
+    pIter(v);
+  }
+  if (res!=NULL) res=pReverse(res);
+  return res;
+}
+
 /// julia: vector to already allocated array (len=p_MaxComp(v,r))
 void  p_Vec2Array(poly v, poly *p, int len, const ring r)
Index: libpolys/polys/monomials/p_polys.h
===================================================================
--- libpolys/polys/monomials/p_polys.h	(revision a718906498691a0860e186cfee5db4fc1142ccd6)
+++ libpolys/polys/monomials/p_polys.h	(revision aa7c1c2e9f1abb961d220f98916b45111ff94b84)
@@ -97,4 +97,5 @@
 
 void  p_Vec2Polys(poly v, poly**p, int *len, const ring r);
+poly  p_Vec2Poly(poly v, int k, const ring r);
 
 /// julia: vector to already allocated array (len=p_MaxComp(v,r))
@@ -881,5 +882,5 @@
 
 // copys monomials of p, allocates new monomials from bin,
-// deletes monomoals of p
+// deletes monomials of p
 static inline poly p_ShallowCopyDelete(poly p, const ring r, omBin bin)
 {
@@ -1653,8 +1654,23 @@
 {
   if (p2==NULL)
+  {
+    if (p1==NULL) return 0;
     return 1;
+  }
   if (p1==NULL)
     return -1;
   return p_LmCmp(p1,p2,r);
+}
+
+static inline int p_CmpPolys(poly p1, poly p2, ring r)
+{
+  if (p2==NULL)
+  {
+    if (p1==NULL) return 0;
+    return 1;
+  }
+  if (p1==NULL)
+    return -1;
+  return p_ComparePolys(p1,p2,r);
 }
 
Index: libpolys/polys/monomials/ring.cc
===================================================================
--- libpolys/polys/monomials/ring.cc	(revision a718906498691a0860e186cfee5db4fc1142ccd6)
+++ libpolys/polys/monomials/ring.cc	(revision aa7c1c2e9f1abb961d220f98916b45111ff94b84)
@@ -1887,5 +1887,5 @@
            (rHasSimpleOrderAA(r) &&
             (rOrder_is_DegOrdering((rRingOrder_t)r->order[1]) ||
-	    ((r->order[1]!=0) &&
+            ((r->order[1]!=0) &&
              rOrder_is_DegOrdering((rRingOrder_t)r->order[2]))))));
 }
@@ -2978,6 +2978,9 @@
 {
   r->VectorOut = (r->order[0] == ringorder_c);
-  r->CanShortOut = TRUE;
-  {
+  if (rIsNCRing(r))
+    r->CanShortOut=FALSE;
+  else
+  {
+    r->CanShortOut = TRUE;
     int i;
     if (rParameter(r)!=NULL)
